
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart4.h"


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart4::Startup() {
int i;

 tile.Create(256,256);
#ifdef datafile
 dl.Seek("zoom.pcx");
 tile.Load(dl.LibFile);
 dl.Seek("zoom.pal");
 mypal.Load(dl.LibFile);
#else
 tile.Load("..\\data\\zoom.pcx");
 mypal.Load("..\\data\\zoom.pal");
#endif
 tile.Remap(&mypal.pal);

 original.Create(320,200);
#ifdef datafile
 dl.Seek("palice.pcx");
 original.Load(dl.LibFile);
 dl.Seek("palice.pal");
 pal1.Load(dl.LibFile);
#else
 original.Load("..\\data\\palice.pcx");
 pal1.Load("..\\data\\palice.pal");
#endif
 original.Remap(&pal1.pal);

 mask.Create(320,200);
 mask.Clear();

#ifdef datafile
 dl.Seek("palice.shd");
 shd.Load(dl.LibFile);
#else
 shd.Load("..\\data\\palice.shd");
#endif

 movsd.Create(100,100);
#ifdef datafile
 dl.Seek("movsd.pcx");
 movsd.Load(dl.LibFile);
#else
 movsd.Load("..\\data\\movsd.pcx");
#endif
 movsd.Remap(&pal1.pal);

 peon.Create(100,100);
#ifdef datafile
 dl.Seek("peon.pcx");
 peon.Load(dl.LibFile);
#else
 peon.Load("..\\data\\peon.pcx");
#endif
 peon.Remap(&pal1.pal);

 troper.Create(100,100);
#ifdef datafile
 dl.Seek("terror.pcx");
 troper.Load(dl.LibFile);
#else
 troper.Load("..\\data\\terror.pcx");
#endif
 troper.Remap(&pal1.pal);

 broncs.Create(100,100);
#ifdef datafile
 dl.Seek("broncs.pcx");
 broncs.Load(dl.LibFile);
#else
 broncs.Load("..\\data\\broncs.pcx");
#endif
 broncs.Remap(&pal1.pal);


 for(i=0;i<360;i++) {
  Stab[i]=sin(i*pi/180);
  Ctab[i]=cos(i*pi/180);
 }
 for(i=0;i<200;i++) {
  ytab[i]=320*i;
 }
 for(i=-128; i<128; i++)
    sint[i+128]=80*sin(abs(i)*pi/256);  //nastavim si sinusy
    // sint[i]=130+(120*cos(sqrt(200-i)*sin(sqrt(320-i))));

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void cpart4::plasmatic(Image scr)
{
  unsigned char px1, px2, py1, py2; //pomocne body
  int x, y;
  unsigned char pom;

  py1=sy1;
  py2=sy2;
  for(y=0; y<200; y++)
   {px1=sx1,px2=sx2;
    for(x=0; x<320; x++)
    {
     pom=sint[py1]+sint[py2]+sint[px1]+sint[px2];
     if (x>0 && y>0 && x<320 && y<200)
      memset((scr.Data+x+y*320),pom,1);
     px1+=1;
     px2+=1;
    }
    py1+=2;
    py2+=1;
  }
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart4::Init() {

 sx1=0, sx2=0, sy1=0, sy2=0; //startovaci indexy

 virtscr.Create(320,200);

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart4::Terminate() {

   tile.Destroy();
   original.Destroy();
   mask.Destroy();

   movsd.Destroy();
   peon.Destroy();
   troper.Destroy();
   broncs.Destroy();

   return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void cpart4::tilezoom(void){
 int i,j;
 float pfx=0,pfy=0;
 unsigned int xt,yt;
 
 for (i=0;i<200;i++) {
  pfx=0;
  for (j=0;j<320;j++)  {
   xt=(long)pfx;
   yt=(long)pfy;
   memcpy(virtscr.Data+j+ytab[i],tile.Data+xt+(yt<<8),1);
   pfx+=zoomindex;
   if (pfx>256) pfx-=256;
  }
  pfy+=zoomindex;
  if (pfy>256) pfy-=256;
 }
}  

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void cpart4::resize(int siz,char *img){
unsigned char onoff[100];
float curpos,posstep;
unsigned char onx, ony, sx, sy,pixel;
unsigned short rx,ry;
int i,sizx,sizy,vx,vy;

 curpos=0;
 posstep=100/(float)siz;
 sizx=160 - (siz>>1);
 sizy=100 - (siz>>1);
 for(i=0;i<100;i++) onoff[i]=0;
 do{
  onoff[(int)curpos]++;
  curpos+=posstep;
 } while (curpos<100);
 
 ry=0;
 for(ony=0;ony<100;ony++)
  for(sy=1;sy<=onoff[ony];sy++){
   rx=0;
   for(onx=0;onx<=99;onx++)
    for(sx=1;sx<=onoff[onx];sx++){
     vy=sizy+ry;
     vx=sizx+rx;
     if( vx<320 && vy<200 && vx>=0 && vy>=0) {
      pixel=*(img+ony*100+onx);
      if (pixel!=0)
       memcpy(virtscr.Data+vy*320+vx,img+ony*100+onx,1);
     }
     rx++;
    }
   ry++;
  }
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

void part1_apply2 ( char* mask, char* orig, char* final, char* shd, int cnt );
#pragma aux part1_apply2 = \
            "mov eax,0                          " \
            "label1:                            " \
            "  mov ah,[esi]                     " \
            "  shr ah,2                         " \
            "  mov al,[ebx]			" \
	    "  mov al,[edx+eax]                 " \
            "  mov [edi],al                     " \
            "  inc esi                          " \
            "  inc edi                          " \
            "  inc ebx                          " \
            "dec ecx                            " \
            "jnz label1                         " \
            parm [esi] [ebx] [edi] [edx] [ecx] \
            modify [eax ebx ecx esi edi];

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart4::Run() {
 int rotangle;

 if (exitflag==1) return Error;
 check();

 svga.Init(mode_320x200);
 svga.Clear();
 svga.SetPalette(&mypal.pal);

/*
 zoomindex=5;
 frameCount=0;
 do {
  zoomindex/=1.01;
  tilezoom();
  if (zoomindex<0.3) zoomindex=5;
  svga.Copy(&virtscr,0,0);
  if (exitflag==1) return Error;
  check();
 } while (frameCount<800);

*/


 int incy=-5;
 int cisl=1;
 int pocet=0;


 // nastavim nejaku tu paletu
 svga.SetPalette(&pal1.pal);
 frameCount=1;
 float indx=0;
 int pos;
 do{
    plasmatic(mask); //vypocitam plasmu
    part1_apply2(mask.Data,original.Data,virtscr.Data,shd.shadetab,64000);
    indx=frameCount*0.5;
    if (indx<220) resize((int)indx,peon.Data);
    if (indx<440 && indx>220) resize(indx-220,broncs.Data);
    if (indx<660 && indx>440) resize(indx-440,movsd.Data);
    if (indx<880 && indx>660) resize(indx-660,troper.Data);
    svga.Copy(&virtscr,0,0);
    //sx1+=3+incy;
    sx1=0;
    sx2=(int)1.2*frameCount;
    sy1=(int)-1.5*frameCount;
    //sy2+=incy*3;
    sy2=0;
    if(((int)(frameCount*0.2)%20)==0) incy+=cisl,pocet++;
    if(pocet==10) cisl=(-1)*cisl,pocet=0;
    if (exitflag==1) return Error;
    check();
    de.music.GetInfo();
    pos=de.music.info->position;
    } while(pos<0x28);

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart4::Done() {

 virtscr.Destroy();
 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


