
#include <i86.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "vdt.h"
#include "global.h"
#include "cpart7.h"


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart7::Startup() {

 picture.Create(640,480);
#ifdef datafile
 dl.Seek("sj086.pcx");
 picture.Load(dl.LibFile);
#else
 picture.Load("..\\data\\sj086.pcx");
#endif
 picpal.Load(&picture);
 picture.Remap(&picpal.pal);

 pestw.Create(100,100);
#ifdef datafile
 dl.Seek("pestw.pcx");
 pestw.Load(dl.LibFile);
#else
 pestw.Load("..\\data\\pestw.pcx");
#endif
 pestw.Remap(&picpal.pal);

 return Success;
}


//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart7::Init() {

 //printf("init OK\n");
 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart7::Terminate() {

 picture.Destroy();
 pestw.Destroy();

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart7::Run() {
int k;

 if (exitflag==1) return Error;
 check();

 svga.Init(mode_640x480);
 svga.Clear();
 svga.SetPalette(&picpal.pal);

 origpal.Load(&picture);

 for (k=0; k<256; k++) {
  pompal.pal[k].r=64;
  pompal.pal[k].g=64;
  pompal.pal[k].b=64;
 }


 //reset timer
 int pos;
 frameCount=0;
 do{
  for (k=0; k<256; k++) {
   if (pompal.pal[k].r > origpal.pal[k].r) pompal.pal[k].r--;
   if (pompal.pal[k].g > origpal.pal[k].g) pompal.pal[k].g--;
   if (pompal.pal[k].b > origpal.pal[k].b) pompal.pal[k].b--;
  }
  svga.SetPalette(&pompal.pal);
  picture.TCopy(&pestw,0,0);
  svga.Copy(&picture,0,0);
  //if keypress
  if (exitflag==1) return Error;
  check();
  de.music.GetInfo();
  pos=de.music.info->position;
 } while (pos<0xE);

 return Success;

}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------

int cpart7::Done() {

 return Success;
}

//-------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------


